'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const core = require('./core-8e67a5c9.js');

const EnterToken = class {
    constructor(hostRef) {
        core.registerInstance(this, hostRef);
        this.token = core.createEvent(this, "token", 7);
    }
    onChange(e) {
        this.value = e.target.value;
        console.log(this.value);
    }
    onKeyDown(ev) {
        if (ev.key === "Enter") {
            this.submit();
        }
    }
    submit() {
        if (this.value && this.value.length > 0) {
            this.token.emit(this.value);
        }
    }
    componentDidLoad() {
        setTimeout(() => {
            this.textarea.focus();
        }, 100);
    }
    render() {
        return (core.h("div", null, core.h("h5", null, "Enter your token"), core.h("textarea", { class: "ta", ref: (r) => (this.textarea = r), value: this.value, onInput: (e) => this.onChange(e), onKeyDown: (e) => this.onKeyDown(e) }), core.h("br", null), core.h("br", null), core.h("input", { type: "submit", onClick: () => this.submit() }, "GO")));
    }
    static get style() { return ".ta {\n  min-width: 500px;\n  min-height: 300px;\n}"; }
};

exports.enter_token = EnterToken;
