import { h } from "@stencil/core";
export class ErrorMessage {
    render() {
        return (h("div", { class: "errorContainer" },
            h("div", { class: "errorIcon" },
                h("svg", { xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 25 25", fill: "none", stroke: "currentColor", "stroke-width": "2", "stroke-linecap": "round", "stroke-linejoin": "round", class: "errorSvg" },
                    h("path", { d: "M10.29 3.86L1.82 18a2 2 0 0 0 1.71 3h16.94a2 2 0 0 0 1.71-3L13.71 3.86a2 2 0 0 0-3.42 0z" }),
                    h("line", { x1: "12", y1: "9", x2: "12", y2: "13" }),
                    h("line", { x1: "12", y1: "17", x2: "12", y2: "17" }))),
            h("div", { class: "errorMessage" }, this.message)));
    }
    static get is() { return "error-message"; }
    static get originalStyleUrls() { return {
        "$": ["error-message.css"]
    }; }
    static get styleUrls() { return {
        "$": ["error-message.css"]
    }; }
    static get properties() { return {
        "message": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "message",
            "reflect": false
        }
    }; }
}
