// TODO [Eelco] I really dislike how this is hard coded. Why not just have a simple mechanism that allows you to
// set the api and bundle urls directly, and use that throughout the code base?
export const HOST_DEFAULTS = {
    prod: {
        apiUrl: 'https://api.pie-api.com/api',
        bundleBaseUrl: 'https://storage.googleapis.com/pie-pits-prod/bundles/'
    },
    stage: {
        apiUrl: 'https://api.dev.pie-api.com/api',
        bundleBaseUrl: 'https://storage.googleapis.com/pie-pits-prod/bundles/'
    },
    dev: {
        apiUrl: 'https://api.dev.pie-api.com/api',
        bundleBaseUrl: 'https://storage.googleapis.com/pie-pits-prod/bundles/'
    },
    qa: {
        apiUrl: 'https://api.dev.pie-api.com/api',
        bundleBaseUrl: 'https://storage.googleapis.com/pie-pits-prod/bundles/'
    },
    local: {
        apiUrl: 'http://localhost:4000/api',
        bundleBaseUrl: 'https://storage.googleapis.com/pie-pits-prod/bundles/'
    }
};
export const PLAYER_HOST_CONFIG = {
    host: HOST_DEFAULTS.prod.apiUrl,
    bundleBaseUrl: HOST_DEFAULTS.prod.bundleBaseUrl,
    // load: "/loadPlayerJson/",
    load: "/player/load",
    saveSession: "/player/save",
    model: "/player/model",
    score: "/player/score"
};
export const CONFIGURE_ENDPOINTS = {
    host: HOST_DEFAULTS.prod.apiUrl,
    save: "/configure/save",
    load: "/configure/load.json"
};
