var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { r as registerInstance, c as createEvent, g as getContext, h, d as getElement } from './core-80804c5e.js';
import { N as NewRelicEnabledClient, F as FetchUtils, b as loadBestVersions, P as PLAYER_HOST_CONFIG, H as HOST_DEFAULTS, l as loadFromPieApi, v as versionedIdtoString, c as lockConfigVersions, u as unlockConfigVersions, d as saveContentItem, V as VERSION, r as releaseContentItem, i as idInfo, a as NewRelicInstrumentationService } from './graphql-f5d6a437.js';
import { A as get$1, B as addPackageToContent, a as addRubric } from './rubric-utils-61de23c8.js';
import { h as pieContentFromConfig } from './utils-e506e807.js';
// Unique ID creation requires a high quality random # generator. In the browser we therefore
// require the crypto API and do not support built-in fallback to lower quality random number
// generators (like Math.random()).
var getRandomValues;
var rnds8 = new Uint8Array(16);
function rng() {
    // lazy load so that environments that need to polyfill have a chance to do so
    if (!getRandomValues) {
        // getRandomValues needs to be invoked in a context where "this" is a Crypto implementation.
        getRandomValues = typeof crypto !== 'undefined' && crypto.getRandomValues && crypto.getRandomValues.bind(crypto);
        if (!getRandomValues) {
            throw new Error('crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported');
        }
    }
    return getRandomValues(rnds8);
}
/**
 * Convert array of 16 byte values to UUID string format of the form:
 * XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX
 */
var byteToHex = [];
for (var i = 0; i < 256; ++i) {
    byteToHex.push((i + 0x100).toString(16).slice(1));
}
function unsafeStringify(arr, offset) {
    if (offset === void 0) { offset = 0; }
    // Note: Be careful editing this code!  It's been tuned for performance
    // and works in ways you may not expect. See https://github.com/uuidjs/uuid/pull/434
    return (byteToHex[arr[offset + 0]] + byteToHex[arr[offset + 1]] + byteToHex[arr[offset + 2]] + byteToHex[arr[offset + 3]] + '-' + byteToHex[arr[offset + 4]] + byteToHex[arr[offset + 5]] + '-' + byteToHex[arr[offset + 6]] + byteToHex[arr[offset + 7]] + '-' + byteToHex[arr[offset + 8]] + byteToHex[arr[offset + 9]] + '-' + byteToHex[arr[offset + 10]] + byteToHex[arr[offset + 11]] + byteToHex[arr[offset + 12]] + byteToHex[arr[offset + 13]] + byteToHex[arr[offset + 14]] + byteToHex[arr[offset + 15]]).toLowerCase();
}
var randomUUID = typeof crypto !== 'undefined' && crypto.randomUUID && crypto.randomUUID.bind(crypto);
var native = {
    randomUUID: randomUUID
};
function v4(options, buf, offset) {
    if (native.randomUUID && !buf && !options) {
        return native.randomUUID();
    }
    options = options || {};
    var rnds = options.random || (options.rng || rng)(); // Per 4.4, set bits for version and `clock_seq_hi_and_reserved`
    rnds[6] = rnds[6] & 0x0f | 0x40;
    rnds[8] = rnds[8] & 0x3f | 0x80; // Copy bytes to buffer, if provided
    if (buf) {
        offset = offset || 0;
        for (var i = 0; i < 16; ++i) {
            buf[offset + i] = rnds[i];
        }
        return buf;
    }
    return unsafeStringify(rnds);
}
var PieApiImageSupport = /** @class */ (function (_super) {
    __extends(PieApiImageSupport, _super);
    function PieApiImageSupport(token, graphql, versionedID, versionedIDGenerator) {
        var _this = _super.call(this) || this;
        _this.token = token;
        _this.graphql = graphql;
        _this.versionedID = versionedID;
        _this.versionedIDGenerator = versionedIDGenerator;
        // Create a FetchUtils instance with tracking info
        _this.fetchUtils = new FetchUtils({
            graphqlEndpoint: _this.graphql,
            hasToken: !!_this.token,
            hasVersionedID: !!_this.versionedID
        });
        return _this;
    }
    PieApiImageSupport.prototype.getTrackingBaseAttributes = function () {
        return {
            graphqlEndpoint: this.graphql,
            hasToken: !!this.token,
            hasVersionedID: !!this.versionedID,
            networkInfo: this.getNetworkInfo()
        };
    };
    PieApiImageSupport.prototype.insert = function (file, done) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, info, uploadResponse, error, e_1, error;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _c.trys.push([0, 3, , 4]);
                        return [4 /*yield*/, this.createUploadRequest(file.type)];
                    case 1:
                        info = _c.sent();
                        return [4 /*yield*/, this.fetchUtils.uploadFile(info.signedURL, file, "image-upload")];
                    case 2:
                        uploadResponse = _c.sent();
                        if (uploadResponse.ok) {
                            done(null, info.publicURL);
                        }
                        else {
                            error = new Error("Upload failed (url " + info.signedURL + ")");
                            if ((_a = this.newRelic) === null || _a === void 0 ? void 0 : _a.isAvailable()) {
                                this.newRelic.noticeError(error, { signedUrl: info.signedURL, status: uploadResponse.status });
                            }
                            done(error, null);
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _c.sent();
                        error = new Error("Upload failed: " + (e_1.message || 'Unknown error'));
                        if ((_b = this.newRelic) === null || _b === void 0 ? void 0 : _b.isAvailable()) {
                            this.newRelic.noticeError(error, { message: e_1.message || 'Unknown error' });
                        }
                        done(error, null);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    PieApiImageSupport.prototype.createUploadRequest = function (contentType) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, query, variables, response, data, errors, uploadError;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        // The new pie api made media ID required for performance (previously ID was optional).
                        // This means we have to treat this edge case:
                        //  If the item is newly created and doesn't have an ID yet (was not saved in the db yet),
                        //  we need to generate the ID, upload the media with that ID and also make sure to use the
                        //  generated ID in pie-api-author for other item-related actions (eg: upload other medias, save item)
                        if (!this.versionedID && this.versionedIDGenerator) {
                            this.versionedID = this.versionedIDGenerator();
                        }
                        query = "\n      mutation RequestMediaUpload($id: ID!, $contentType: String!) {\n        requestMediaUpload(id: $id, contentType: $contentType) {\n          signedURL\n          publicURL\n        }\n      }\n    ";
                        variables = {
                            id: this.versionedID || 'default-id',
                            contentType: contentType
                        };
                        return [4 /*yield*/, this.fetchUtils.executeGraphQL(this.graphql, this.token, query, variables)];
                    case 1:
                        response = _c.sent();
                        data = get$1(response, "data.requestMediaUpload");
                        if (!data) {
                            errors = get$1(response, "errors", []);
                            uploadError = errors && errors.length ? errors.find(function (e) { return e.path && e.path.includes && e.path.includes("requestMediaUpload"); }) : null;
                            if ((_a = this.newRelic) === null || _a === void 0 ? void 0 : _a.isAvailable()) {
                                this.newRelic.noticeError(uploadError || new Error("Unknown error"), { errors: errors });
                            }
                            throw uploadError
                                ? new Error(uploadError.message)
                                : new Error("Unknown gql error: " + JSON.stringify(response));
                        }
                        return [2 /*return*/, data];
                }
            });
        });
    };
    PieApiImageSupport.prototype.delete = function (src, done) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, mut, response, info, errors, deleteError, errorMessage, error, deleteResponse, error, e_2;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!src) {
                            done();
                            return [2 /*return*/];
                        }
                        mut = "\n      mutation RequestMediaDelete($publicURL: String!) {\n        requestMediaDelete(publicURL: $publicURL) {\n          signedURL\n        }\n      }\n    ";
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 4, , 5]);
                        return [4 /*yield*/, this.fetchUtils.executeGraphQL(this.graphql, this.token, mut, { publicURL: src })];
                    case 2:
                        response = _c.sent();
                        info = get$1(response, "data.requestMediaDelete");
                        if (!info) {
                            errors = get$1(response, "errors", []);
                            deleteError = (errors && errors.length) ? errors.find(function (e) { return e.path && e.path.includes && e.path.includes("requestMediaDelete"); }) : null;
                            errorMessage = deleteError ? deleteError.message : "no info in json?";
                            error = new Error(errorMessage);
                            if ((_a = this.newRelic) === null || _a === void 0 ? void 0 : _a.isAvailable()) {
                                this.newRelic.noticeError(error, { errors: errors });
                            }
                            throw error;
                        }
                        return [4 /*yield*/, this.fetchUtils.deleteWithSignedUrl(info.signedURL, "image-delete")];
                    case 3:
                        deleteResponse = _c.sent();
                        if (deleteResponse.ok) {
                            done();
                        }
                        else {
                            error = new Error("DELETE failed");
                            if ((_b = this.newRelic) === null || _b === void 0 ? void 0 : _b.isAvailable()) {
                                this.newRelic.noticeError(error, {});
                            }
                            throw error;
                        }
                        return [3 /*break*/, 5];
                    case 4:
                        e_2 = _c.sent();
                        done(e_2);
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    return PieApiImageSupport;
}(NewRelicEnabledClient));
var PieApiSoundSupport = /** @class */ (function (_super) {
    __extends(PieApiSoundSupport, _super);
    function PieApiSoundSupport(token, graphql, versionedID, versionedIDGenerator) {
        var _this = _super.call(this) || this;
        _this.token = token;
        _this.graphql = graphql;
        _this.versionedID = versionedID;
        _this.versionedIDGenerator = versionedIDGenerator;
        // Create a FetchUtils instance with tracking info
        _this.fetchUtils = new FetchUtils({
            graphqlEndpoint: _this.graphql,
            hasToken: !!_this.token,
            hasVersionedID: !!_this.versionedID
        });
        return _this;
    }
    PieApiSoundSupport.prototype.getTrackingBaseAttributes = function () {
        return {
            graphqlEndpoint: this.graphql,
            hasToken: !!this.token,
            hasVersionedID: !!this.versionedID,
            networkInfo: this.getNetworkInfo()
        };
    };
    PieApiSoundSupport.prototype.insert = function (file, done) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, typeParsed, info, uploadResponse, error, e_3, error;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _c.trys.push([0, 3, , 4]);
                        typeParsed = file.type.replace('x-', '');
                        return [4 /*yield*/, this.createUploadRequest(typeParsed)];
                    case 1:
                        info = _c.sent();
                        return [4 /*yield*/, this.fetchUtils.uploadFile(info.signedURL, file, "sound-upload")];
                    case 2:
                        uploadResponse = _c.sent();
                        if (uploadResponse.ok) {
                            done(null, info.publicURL);
                        }
                        else {
                            error = new Error("Upload failed (url " + info.signedURL + ")");
                            if ((_a = this.newRelic) === null || _a === void 0 ? void 0 : _a.isAvailable()) {
                                this.newRelic.noticeError(error, { signedUrl: info.signedURL, status: uploadResponse.status });
                            }
                            done(error, null);
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        e_3 = _c.sent();
                        error = new Error("Upload failed: " + e_3.message);
                        if ((_b = this.newRelic) === null || _b === void 0 ? void 0 : _b.isAvailable()) {
                            this.newRelic.noticeError(error, { message: e_3.message });
                        }
                        done(error, null);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    PieApiSoundSupport.prototype.createUploadRequest = function (contentType) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, query, response, data, errors, uploadError;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        // The new pie api made media ID required for performance (previously ID was optional).
                        // This means we have to treat this edge case:
                        //  If the item is newly created and doesn't have an ID yet (was not saved in the db yet),
                        //  we need to generate the ID, upload the media with that ID and also make sure to use the
                        //  generated ID in pie-api-author for other item-related actions (eg: upload other medias, save item)
                        if (!this.versionedID && this.versionedIDGenerator) {
                            this.versionedID = this.versionedIDGenerator();
                        }
                        query = "\n      mutation RequestMediaUpload($id: ID!, $contentType: String!) {\n        requestMediaUpload(id: $id, contentType: $contentType) {\n        signedURL\n        publicURL\n      }\n    }";
                        return [4 /*yield*/, this.fetchUtils.executeGraphQL(this.graphql, this.token, query, {
                                id: this.versionedID,
                                contentType: contentType
                            })];
                    case 1:
                        response = _c.sent();
                        data = get$1(response, "data.requestMediaUpload");
                        if (!data) {
                            errors = get$1(response, "errors");
                            uploadError = errors.find(function (e) { return e.path.includes("requestMediaUpload"); });
                            if ((_a = this.newRelic) === null || _a === void 0 ? void 0 : _a.isAvailable()) {
                                this.newRelic.noticeError(uploadError, { errors: errors });
                            }
                            throw uploadError
                                ? new Error(uploadError.message)
                                : new Error("Unknown gql error: " + JSON.stringify(response));
                        }
                        return [2 /*return*/, data];
                }
            });
        });
    };
    PieApiSoundSupport.prototype.delete = function (src, done) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, mut, response, info, errors, deleteError, error, deleteResponse, error, e_4;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!src) {
                            return [2 /*return*/];
                        }
                        mut = "\n      mutation RequestMediaDelete($publicURL: String!) {\n        requestMediaDelete(publicURL: $publicURL) {\n        signedURL\n      }\n    }";
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 4, , 5]);
                        return [4 /*yield*/, this.fetchUtils.executeGraphQL(this.graphql, this.token, mut, { publicURL: src })];
                    case 2:
                        response = _c.sent();
                        info = get$1(response, "data.requestMediaDelete");
                        if (!info) {
                            errors = get$1(response, "errors");
                            deleteError = (errors || []).find(function (e) { return e.path.includes("requestMediaDelete"); });
                            error = new Error(deleteError ? deleteError.message : "no info in json?");
                            if ((_a = this.newRelic) === null || _a === void 0 ? void 0 : _a.isAvailable()) {
                                this.newRelic.noticeError(error, { errors: errors });
                            }
                            throw error;
                        }
                        return [4 /*yield*/, this.fetchUtils.deleteWithSignedUrl(info.signedURL, "sound-delete")];
                    case 3:
                        deleteResponse = _c.sent();
                        if (deleteResponse.ok) {
                            done();
                        }
                        else {
                            error = new Error("DELETE failed");
                            if ((_b = this.newRelic) === null || _b === void 0 ? void 0 : _b.isAvailable()) {
                                this.newRelic.noticeError(error, {});
                            }
                            throw error;
                        }
                        return [3 /*break*/, 5];
                    case 4:
                        e_4 = _c.sent();
                        done(e_4);
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    return PieApiSoundSupport;
}(NewRelicEnabledClient));
// const log: any = console.log.bind(console, "[pie-versions]");
var versions;
/**
 * Use these as a fallback if all else fails. To be removed.
 */
var LegacyPieVersions = {
    "@pie-element/categorize": "6.5.4",
    "@pie-element/charting": "2.5.4",
    "@pie-element/drag-in-the-blank": "3.7.4",
    "@pie-element/drawing-response": "3.5.3",
    "@pie-element/ebsr": "6.3.4",
    "@pie-element/explicit-constructed-response": "3.7.4",
    "@pie-element/extended-text-entry": "6.3.3",
    "@pie-element/graph-lines": "4.0.7",
    "@pie-element/graphing": "3.4.4",
    "@pie-element/hotspot": "4.7.4",
    "@pie-element/image-cloze-association": "3.4.4",
    "@pie-element/inline-choice": "2.10.9",
    "@pie-element/inline-dropdown": "3.5.4",
    "@pie-element/match": "4.5.4",
    "@pie-element/match-list": "1.11.4",
    "@pie-element/math-inline": "5.4.4",
    "@pie-element/multiple-choice": "5.5.4",
    "@pie-element/number-line": "5.9.4",
    "@pie-element/placement-ordering": "7.3.4",
    "@pie-element/point-intercept": "4.5.8",
    "@pie-element/rubric": "1.5.2",
    "@pie-element/ruler": "3.11.3",
    "@pie-element/select-text": "6.3.4",
    "@pie-element/text-entry": "5.0.7",
};
var noOlderThan = function (n, minutes) {
    var diff = new Date().getTime() - n;
    return diff < minutes * 1000 * 60;
};
var KEY = "__pie_api_components_author_versions__";
var localVersions = function () {
    try {
        var local = localStorage.getItem(KEY);
        var o = JSON.parse(local);
        if (!o) {
            return;
        }
        if (noOlderThan(o.createdAt, 60)) {
            return o.versions;
        }
    }
    catch (e) {
        console.error(e.message);
    }
};
var get = function (token, apiUrl) { return __awaiter(void 0, void 0, void 0, function () {
    var local, r, e_5;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                _c.trys.push([0, 4, , 5]);
                if (!!versions) return [3 /*break*/, 3];
                local = localVersions();
                if (!local) return [3 /*break*/, 1];
                versions = local;
                return [3 /*break*/, 3];
            case 1: return [4 /*yield*/, loadBestVersions(token, apiUrl)];
            case 2:
                r = _c.sent();
                versions = r.reduce(function (acc, nv) {
                    acc[nv.pie] = nv.version;
                    return acc;
                }, {});
                localStorage.setItem(KEY, JSON.stringify({ versions: versions, createdAt: new Date().getTime() }));
                _c.label = 3;
            case 3: return [2 /*return*/, versions];
            case 4:
                e_5 = _c.sent();
                console.warn("[pie-versions:get] " + apiUrl + " - Error loading best versions - returning fallback versions, this will throw an error in future");
                console.error(e_5.message);
                return [2 /*return*/, LegacyPieVersions];
            case 5: return [2 /*return*/];
        }
    });
}); };
var PieApiAuthor = /** @class */ (function () {
    function class_1(hostRef) {
        var _this = this;
        registerInstance(this, hostRef);
        /**
         * Choose 'dev' , 'stage' or 'prod' environments for back end.
         */
        this.host = "prod";
        /**
         * used to automatically re-fetch the bundle (in case we get a 503); defaults to false
         */
        this.reFetchBundle = false;
        /**
         * For development purposes only - allows alternate api endpoints to be provided.
         */
        this.apiConfig = PLAYER_HOST_CONFIG;
        /**
         * Adds a preview view which will render the content in another tab as it may appear to a student or instructor.
         */
        this.addPreview = false;
        /**
         * Enable screen recording with logrocket.
         * Note: not to be used in production unless for temporary use to track down a specific user problem.
         */
        this.recordScreen = false;
        /**
         * Enable exception tracking.
         */
        this.exceptions = false;
        /**
         * If true, the `@version` tag for elements in the configuration will be ignored and a static version for that
         * interaction type determined by the current release of this pie-api-author component will be used.
         */
        this.lockVersions = false;
        this.generateUUID = function () {
            // This function is a callback sent to PieApiImageSupport and PieApiSoundSupport, to treat a specific edge case:
            //  If the item is newly created and doesn't have an ID yet (was not saved in the db yet),
            //  we need to generate the ID, upload the media with that ID and also make sure to use the
            //  generated ID in pie-api-author for other item-related actions (eg: upload other medias, save item)
            _this.contentId = v4();
            // Store the generated id
            return _this.contentId;
        };
        this.contentLoaded = createEvent(this, "contentLoaded", 7);
        this.contentIdValidated = createEvent(this, "contentIdValidated", 7);
        this.recordingStarted = createEvent(this, "recordingStarted", 7);
        this.doc = getContext(this, "document");
    }
    class_1.prototype.watchHostEnvironment = function (newVal) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!newVal) return [3 /*break*/, 2];
                        this.apiConfig.host = HOST_DEFAULTS[newVal].apiUrl;
                        this.apiConfig.bundleBaseUrl = HOST_DEFAULTS[newVal].bundleBaseUrl;
                        if (!this.token) return [3 /*break*/, 2];
                        return [4 /*yield*/, get(this.token, this.apiConfig.host)];
                    case 1:
                        _c.sent();
                        _c.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Utility method to add a `@pie-element/rubric` section to an item config when creating an item should be used before setting the config.
     *
     * @deprecated this method is for temporary use, will be removed at next major release
     *
     * @param config the item config to mutate
     * @param rubricModel optional model to pass to `@pie-element/rubric`
     */
    class_1.prototype.addRubricToConfig = function (config, rubricModel) {
        return __awaiter(this, void 0, void 0, function () {
            var configPieContent, updatedConfig;
            return __generator(this, function (_c) {
                console.warn("This function is deprecated. Use complex-rubric functionality instead.");
                if (!rubricModel) {
                    rubricModel = {
                        id: "rubric",
                        element: "pie-rubric",
                        points: ["", "", "", ""],
                        excludeZero: false,
                    };
                }
                configPieContent = pieContentFromConfig(config);
                addPackageToContent(configPieContent, "@pie-element/rubric", rubricModel);
                updatedConfig = addRubric(configPieContent);
                return [2 /*return*/, updatedConfig];
            });
        });
    };
    class_1.prototype.getOverrides = function () {
        var overrides = undefined;
        try {
            if (typeof this.overrides === "string") {
                overrides = JSON.parse(this.overrides);
            }
            else {
                if (this.overrides) {
                    overrides = this.overrides;
                }
            }
        }
        catch (e) { }
        return overrides;
    };
    /**
     * Loads a content item from `pie-api` host into the view.
     *
     * @param contentId the unique versioned identifer `id@version` for the content item to load. If this param
     * is not provided and `content-id` attribute has a value, that value will be used to load the content item.
     */
    class_1.prototype.load = function (contentId) {
        return __awaiter(this, void 0, void 0, function () {
            var idToLoad, contentData, stringVersionId;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!this.token) {
                            return [2 /*return*/];
                        }
                        idToLoad = contentId ? contentId : this.contentId;
                        if (!idToLoad) return [3 /*break*/, 2];
                        return [4 /*yield*/, loadFromPieApi(this.token, idToLoad, this.apiConfig.host, this.getOverrides())];
                    case 1:
                        contentData = _c.sent();
                        this.contentConfig = contentData.config;
                        stringVersionId = versionedIdtoString({
                            id: contentData.id,
                            version: contentData.version,
                        });
                        this.contentId = stringVersionId;
                        this.contentLoaded.emit({
                            id: this.contentId,
                            config: this.contentConfig,
                        });
                        _c.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Creates a new content item from the currently loaded contents.
     *
     * @param preReleaseType - see preRelaseType for the `save` method
     */
    class_1.prototype.create = function (preReleaseType) {
        if (preReleaseType === void 0) { preReleaseType = "premajor"; }
        return __awaiter(this, void 0, void 0, function () {
            var cc;
            return __generator(this, function (_c) {
                cc = this.shouldLock()
                    ? lockConfigVersions(this.contentConfig, this.versions, {})
                    : unlockConfigVersions(this.contentConfig);
                return [2 /*return*/, saveContentItem(this.token, this.contentId || null, preReleaseType, cc, this.collectionId ? [this.collectionId] : null, this.apiConfig.host)];
            });
        });
    };
    /**
     * Saves an update to an existing pre-released content item.
     * The content item version must be in pre-release state.
     *
     * the `preReleaseType` param determines what kind of version update, if any, will be performed.
     *
     * `null` - (default) writes over existing pre-release content, , e.g.`1.0.0-draft.0 -> 1.0.0-draft.0`\n
     * `prerelease` - writes in increment to the prerelease version, e.g. `1.0.0-draft.0 -> 1.0.0-draft.1`\n
     * `premajor` - creates a new major release from version, e.g. `1.0.0-draft.1 -> 2.0.0-draft.0`\n
     * `preminor` - creates a new minor release from version, e.g. `1.0.0-draft.1 -> 1.1.0-draft.0`\n
     * `prepatch` - creates a new patch release from version, e.g. `1.0.0-draft.1 -> 1.0.1-draft.0`\m
     *
     * @param preReleaseType - the type of update to perform
     */
    class_1.prototype.save = function (preReleaseType) {
        if (preReleaseType === void 0) { preReleaseType = null; }
        return __awaiter(this, void 0, void 0, function () {
            var newVersionedId, cc;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!this.contentConfig) return [3 /*break*/, 2];
                        cc = this.shouldLock()
                            ? lockConfigVersions(this.contentConfig, this.versions, {})
                            : unlockConfigVersions(this.contentConfig);
                        return [4 /*yield*/, saveContentItem(this.token, this.contentId, preReleaseType, cc, this.collectionId ? [this.collectionId] : null, this.apiConfig.host)];
                    case 1:
                        newVersionedId = _c.sent();
                        if (newVersionedId) {
                            this.contentId = newVersionedId;
                            return [2 /*return*/, newVersionedId];
                        }
                        else {
                            return [2 /*return*/, Promise.resolve(null)];
                        }
                        return [3 /*break*/, 3];
                    case 2: return [2 /*return*/, Promise.resolve(null)];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    class_1.prototype.version = function () {
        return Promise.resolve(VERSION);
    };
    /**
     * this method is for having the possibility to access validateModels from player <br/><br/> It returns the model of the item and errors field which contains the errors returned by validate function in controller. It is an asynchronous method, so it needs to be called with await
     *
     */
    class_1.prototype.validate = function () {
        if (this.pieConfigEl) {
            return this.pieConfigEl.validateModels();
        }
        return null;
    };
    /**
     * Release a pre-release version of the content currently loaded in the authoring view.
     *
     * Throws an exception if the version of the current Content Item does not have a pre-release tag e.g.`1.0.1-draft`
     *
     *  example:
     * (`contentId = 'abc@1.0.1-draft`)
     *
     *  `this.release() => 'abc@1.0.1`'
     *
     */
    class_1.prototype.release = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_c) {
                return [2 /*return*/, releaseContentItem(this.token, this.contentId, this.apiConfig.host)];
            });
        });
    };
    /**
     * TODO
     * Gets a list of all versions that exist for this Content Item.
     */
    class_1.prototype.getVersions = function () {
        return Promise.resolve([""]);
    };
    class_1.prototype.onTokenChange = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!this.token) return [3 /*break*/, 2];
                        return [4 /*yield*/, get(this.token, this.apiConfig.host)];
                    case 1:
                        _c.sent();
                        _c.label = 2;
                    case 2:
                        this.load(this.contentId);
                        return [2 /*return*/];
                }
            });
        });
    };
    class_1.prototype.watchContentId = function (newVal) {
        return __awaiter(this, void 0, void 0, function () {
            var info;
            return __generator(this, function (_c) {
                info = idInfo(newVal);
                this.contentIdValidated.emit({ valid: !!info, status: info });
                return [2 /*return*/];
            });
        });
    };
    class_1.prototype.shouldLock = function () {
        return !this.overrides && this.lockVersions;
    };
    class_1.prototype.watchRecordScreen = function (newVal, oldVal) {
        if (newVal && newVal !== oldVal) {
            if (this.newRelic && this.recordScreenIdentity) {
                // Set user identity for New Relic session
                this.newRelic.setUserId(this.recordScreenIdentity);
                this.recordingStarted.emit("Session recording started with New Relic");
            }
        }
    };
    class_1.prototype.getImageSupport = function () {
        return new PieApiImageSupport(this.token, this.apiConfig.host + "/graphql", this.contentId, this.generateUUID);
    };
    class_1.prototype.getUploadSoundSupport = function () {
        return new PieApiSoundSupport(this.token, this.apiConfig.host + "/graphql", this.contentId, this.generateUUID);
    };
    class_1.prototype.componentWillLoad = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        if (this.token) {
                            get(this.token, this.apiConfig.host);
                        }
                        this.newRelic = new NewRelicInstrumentationService(this.doc);
                        this.newRelic.setApplicationVersion("pie-api-components@" + VERSION);
                        this.newRelic.setCustomAttribute('componentType', 'pie-api-author');
                        if (this.recordScreen) {
                            this.watchRecordScreen(this.recordScreen, false);
                        }
                        this.watchHostEnvironment(this.host);
                        _c = this;
                        return [4 /*yield*/, get(this.token, this.apiConfig.host)];
                    case 1:
                        _c.versions = _d.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    class_1.prototype.connectedCallback = function () {
        var _this = this;
        /**
         * Some stenciljs bug w/ this binding in event listeners, need to bind it correctly.
         */
        this.onModelUpdated = (function (e) {
            console.log("! this:", _this);
            var unlocked = unlockConfigVersions(e.detail);
            _this.contentConfig = unlocked;
        }).bind(this);
        if (!this.versions) {
            get(this.token, this.apiConfig.host).then(function (v) { return (_this.versions = v); });
        }
    };
    class_1.prototype.componentDidLoad = function () {
        if (this.pieConfigEl) {
            this.pieConfigEl.VERSION = VERSION;
        }
    };
    class_1.prototype.getConfigParsed = function (sanctioned) {
        var _c, _d;
        var configSettings = this.configSettings;
        if (this.configSettings) {
            var elName = Object.keys(this.configSettings)[0];
            configSettings = Object.assign(Object.assign({}, this.configSettings), (_c = {}, _c[elName] = Object.assign({ pieApi: {
                    token: this.token,
                    host: this.apiConfig.host,
                } }, this.configSettings[elName]), _c));
        }
        else if (sanctioned.elements) {
            var value = Object.keys(sanctioned.elements).map(function (key) { return sanctioned.elements[key]; })[0];
            var elName = "@" + value.split("@")[1];
            configSettings = (_d = {},
                _d[elName] = {
                    pieApi: {
                        token: this.token,
                        host: this.apiConfig.host,
                    },
                },
                _d);
        }
        return configSettings;
    };
    class_1.prototype.render = function () {
        var _this = this;
        if (this.contentConfig && this.versions) {
            var is = this.getImageSupport();
            var us = this.getUploadSoundSupport();
            var sanctioned = lockConfigVersions(this.contentConfig, this.versions, this.getOverrides());
            var configSettings = this.getConfigParsed(sanctioned);
            return (h("pie-author", { onModelUpdated: this.onModelUpdated, bundleHost: this.host, defaultComplexRubricModel: this.defaultComplexRubricModel, config: sanctioned, configSettings: configSettings, addPreview: this.addPreview, imageSupport: is, uploadSoundSupport: us, ref: function (el) { return (_this.pieConfigEl = el); }, isInsidePieApiAuthor: true, bundleEndpoints: this.bundleEndpoints, reFetchBundle: this.reFetchBundle }));
        }
        else {
            return h("div", null, "not loaded");
        }
    };
    Object.defineProperty(class_1.prototype, "el", {
        get: function () { return getElement(this); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(class_1, "watchers", {
        get: function () {
            return {
                "host": ["watchHostEnvironment"],
                "token": ["onTokenChange"],
                "contentId": ["watchContentId"],
                "recordScreen": ["watchRecordScreen"]
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(class_1, "style", {
        get: function () { return ".pie-api-player img{max-width:inherit;max-height:inherit}.book-title-k5{text-decoration:underline}.book-title{font-style:italic}.block-quote,.text-block{font-family:serif;margin-left:20%;margin-right:20%;margin-top:5px;margin-bottom:5px;width:60%;border:1px solid #000;padding:2px;display:block}.short-quote{font-weight:700}span.short-quote:before{content:open-quote}span.short-quote:after{content:close-quote}.word-callout{text-decoration:underline}.relative-emphasis{text-transform:uppercase}.content-emphasis{font-weight:700;color:red}span.passage-title:before{content:open-quote}span.passage-title:after{content:close-quote}.proper-name,.variable{font-style:italic}.equation-block{text-align:center;margin-left:20%;margin-right:20%;margin-top:5px;margin-bottom:5px;width:60%;padding:2px;display:block}.embedded-error{font-style:italic}div.passage-subtitle,div.passage-title{font-weight:700;text-align:center}div.passage-author{text-align:center}.p-number{float:left;font-size:.85em}.numbered-paragraph{margin-left:36px}\@media print{.kds-noprint,.noprint{display:none}}.abs,.kds-absolute{border-left:1px solid #000;border-right:1px solid #000;padding:0 .3em 0 .3em}.kds-border-1{border:1px solid #000}.kds-border-2{border:2px solid #000}.center,.kds-center{margin:0;text-align:center}.kds-exponent{font-size:85%}.kds-exponent,sup.frac{margin-left:-.4em;position:relative;top:-1.4em}sup.frac{font-size:70%}.kds-fillin{display:inline-block}.fillin,.kds-fillin{border:1px solid #000;margin:0 .2em;padding-left:1em}.fillin{display:inline-block;*display:inline}.kds-font-larger{font-size:larger}.kds-font-smaller{font-size:smaller}table.kds-fraction{border:0;display:inline-block;font-size:85%;margin:0;padding:0;vertical-align:middle}table.kds-fraction>tbody>tr>td.kds-numerator{border-bottom:1px solid #000;border-left:0;border-right:0;border-top:0;text-align:center}table.kds-fraction>tbody>tr>td.kds-denominator{border:0;text-align:center}table.frac{display:inline-block;*display:inline;vertical-align:middle;font-size:85%;border:0;margin:0;padding:0}.frac .nu{border-left:0;border-top:0;border-right:0;border-bottom:1px solid #000;text-align:center}.frac .de{border:0;text-align:center}.kds-hanging-indent{margin:0;padding-left:3em;text-indent:-3em}.kds-image-caption{font-family:Verdana,Arial,sans-serif;text-align:center}.kds-image-left{float:left;margin-right:5px}.kds-image-right{float:right;margin-left:5px}.indent,.kds-indent{text-indent:3em}.kds-nowrap{display:inline-block;white-space:nowrap}.kds-overline{text-decoration:overline}.kds-parentheses{font-family:Arial Narrow,Arial,sans-serif}.kds-parentheses,b.frac{font-size:300%;font-weight:400;position:relative;top:8px}b.frac{font-family:arial narrow}.kds-pi{font-family:Times New Roman,serif;font-size:1.2em}.newradical{border-collapse:collapse;display:inline-block;*display:inline;vertical-align:middle}.newradical td{border:0;padding:0;vertical-align:top}.newradical td.vinculum{border-top:1px solid #000;padding:0;vertical-align:top}.newradical div.exp{font-size:.7em;position:relative;left:7px;bottom:5px}.kds-underline,.under{text-decoration:underline}.kds-verdana2t,.Verdana2t{border:1px solid #fff;text-align:left;text-decoration:none;vertical-align:top}.kds-whole-number{display:inline-block}.kds-whole-number,.whole{font-size:120%;margin:0 0 0 .2em}.whole{display:inline-block;*display:inline}table.KdsTable01{border:1px solid #000;border-collapse:collapse;border-spacing:0}table.KdsTable01>tbody>tr>th{font-weight:400}table.KdsTable01>tbody>tr>th,table.KdsTable01>tbody>tr>th.bold{background-color:#d3d3d3;border:1px solid #000;padding:2px;text-align:center}table.KdsTable01>tbody>tr>th.bold{font-weight:700}table.KdsTable01>tbody>tr>td,table.KdsTable01>tbody>tr>td.bold{border:1px solid #000;padding:2px;text-align:center}table.KdsTable01>tbody>tr>td.bold{font-weight:700}table.KdsTable02{border:1px solid #000;border-collapse:collapse;border-spacing:0}table.KdsTable02>tbody>tr>th{background-color:#d3d3d3;font-weight:400}table.KdsTable02>tbody>tr>td,table.KdsTable02>tbody>tr>th{border:1px solid #000;padding:2px}.lrn_feature h3{margin-top:0!important}#item,#stimulus{width:50%;float:left}.table{width:100%;margin-bottom:1em;background-color:transparent}th{text-align:inherit}.table td,.table th{padding:.75em;vertical-align:top;border-top:1px solid #dee2e6}.table thead th{vertical-align:bottom;border-bottom:2px solid #dee2e6}.table-bordered,.table-bordered td,.table-bordered th{border:1px solid #dee2e6}.table-bordered thead td,.table-bordered thead th{border-bottom-width:2px}"; },
        enumerable: true,
        configurable: true
    });
    return class_1;
}());
export { PieApiAuthor as pie_api_author };
