import { E2EPage } from "@stencil/core/dist/testing";
export declare type Interceptor = {
    body?: string | object;
    match?: string;
    gqlOperationMatch?: {
        match: string;
        body: string;
    }[];
    status?: number;
    headers?: any;
    contenType?: string;
};
export declare class PageRequestInterceptor {
    page: E2EPage;
    interceptors: Interceptor[];
    constructor(page: any);
    addInterceptor(interceptor: Interceptor): void;
    setInterceptor(interceptor: Interceptor): void;
    getGqlOperation(request: any, operationMatches: any[]): any;
}
