'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const core = require('./core-8e67a5c9.js');

const ErrorMessage = class {
    constructor(hostRef) {
        core.registerInstance(this, hostRef);
    }
    render() {
        return (core.h("div", { class: "errorContainer" }, core.h("div", { class: "errorIcon" }, core.h("svg", { xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 25 25", fill: "none", stroke: "currentColor", "stroke-width": "2", "stroke-linecap": "round", "stroke-linejoin": "round", class: "errorSvg" }, core.h("path", { d: "M10.29 3.86L1.82 18a2 2 0 0 0 1.71 3h16.94a2 2 0 0 0 1.71-3L13.71 3.86a2 2 0 0 0-3.42 0z" }), core.h("line", { x1: "12", y1: "9", x2: "12", y2: "13" }), core.h("line", { x1: "12", y1: "17", x2: "12", y2: "17" }))), core.h("div", { class: "errorMessage" }, this.message)));
    }
    static get style() { return ".errorSvg {\n  height: 250px;\n  width: 250px;\n  stroke: lightGrey;\n}\n\n.errorMessage {\n  font-family: sans-serif;\n}\n\n.errorContainer {\n  display: -ms-flexbox;\n  display: flex;\n  -ms-flex-direction: column;\n  flex-direction: column;\n  -ms-flex-align: center;\n  align-items: center;\n}"; }
};

exports.error_message = ErrorMessage;
