'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const core = require('./core-8e67a5c9.js');

const PieSpinner = class {
    constructor(hostRef) {
        core.registerInstance(this, hostRef);
        /**
         * Shows the spinner
         */
        this.active = true;
    }
    render() {
        return (core.h("div", null, !this.active && core.h("slot", null), this.active ?
            core.h("div", { id: "pie-spinner-container" }, core.h("div", { id: "pie-spinner" }, core.h("svg", { class: "lds-spinner", width: "200px", height: "200px", xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 100 100", preserveAspectRatio: "xMidYMid" }, core.h("g", { transform: "rotate(0 50 50)" }, core.h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, core.h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-1.1916666666666667s", repeatCount: "indefinite" }))), core.h("g", { transform: "rotate(30 50 50)" }, core.h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, core.h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-1.0833333333333333s", repeatCount: "indefinite" }))), core.h("g", { transform: "rotate(60 50 50)" }, core.h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, core.h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.9750000000000001s", repeatCount: "indefinite" }))), core.h("g", { transform: "rotate(90 50 50)" }, core.h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, core.h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.8666666666666667s", repeatCount: "indefinite" }))), core.h("g", { transform: "rotate(120 50 50)" }, core.h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, core.h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.7583333333333333s", repeatCount: "indefinite" }))), core.h("g", { transform: "rotate(150 50 50)" }, core.h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, core.h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.65s", repeatCount: "indefinite" }))), core.h("g", { transform: "rotate(180 50 50)" }, core.h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, core.h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.5416666666666666s", repeatCount: "indefinite" }))), core.h("g", { transform: "rotate(210 50 50)" }, core.h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, core.h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.43333333333333335s", repeatCount: "indefinite" }))), core.h("g", { transform: "rotate(240 50 50)" }, core.h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, core.h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.325s", repeatCount: "indefinite" }))), core.h("g", { transform: "rotate(270 50 50)" }, core.h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, core.h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.21666666666666667s", repeatCount: "indefinite" }))), core.h("g", { transform: "rotate(300 50 50)" }, core.h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, core.h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.10833333333333334s", repeatCount: "indefinite" }))), core.h("g", { transform: "rotate(330 50 50)" }, core.h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, core.h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "0s", repeatCount: "indefinite" }))))))
            :
                core.h("div", null)));
    }
    static get style() { return "#pie-spinner-container {\n  display: -ms-flexbox;\n  display: flex;\n  -ms-flex-align: center;\n  align-items: center;\n  -ms-flex-pack: center;\n  justify-content: center;\n  width: 100%;\n}\n#pie-spinner {\n  max-width: 50%;\n}"; }
};

exports.pie_spinner = PieSpinner;
