import { r as registerInstance, c as createEvent, h } from './core-80804c5e.js';
var EnterToken = /** @class */ (function () {
    function EnterToken(hostRef) {
        registerInstance(this, hostRef);
        this.token = createEvent(this, "token", 7);
    }
    EnterToken.prototype.onChange = function (e) {
        this.value = e.target.value;
        console.log(this.value);
    };
    EnterToken.prototype.onKeyDown = function (ev) {
        if (ev.key === "Enter") {
            this.submit();
        }
    };
    EnterToken.prototype.submit = function () {
        if (this.value && this.value.length > 0) {
            this.token.emit(this.value);
        }
    };
    EnterToken.prototype.componentDidLoad = function () {
        var _this = this;
        setTimeout(function () {
            _this.textarea.focus();
        }, 100);
    };
    EnterToken.prototype.render = function () {
        var _this = this;
        return (h("div", null, h("h5", null, "Enter your token"), h("textarea", { class: "ta", ref: function (r) { return (_this.textarea = r); }, value: this.value, onInput: function (e) { return _this.onChange(e); }, onKeyDown: function (e) { return _this.onKeyDown(e); } }), h("br", null), h("br", null), h("input", { type: "submit", onClick: function () { return _this.submit(); } }, "GO")));
    };
    Object.defineProperty(EnterToken, "style", {
        get: function () { return ".ta{min-width:500px;min-height:300px}"; },
        enumerable: true,
        configurable: true
    });
    return EnterToken;
}());
export { EnterToken as enter_token };
