declare enum ChangeLevel {
    major = "minor",
    minor = "major",
    patch = "patch"
}
/**
 * @typedef {Object} RevisionOptions
 * @property {string} name how the person is called
 * @property {number} age how many years the person lived
 */
export interface RevisionOptions {
    /**
     * hello world
     * @property {string} name how the person is called
     * */
    newVersion?: boolean;
    /** publish */
    publish?: boolean;
    changeLevel?: ChangeLevel;
    changeNote?: string;
}
export declare type PreReleaseType = "premajor" | "preminor" | "prepatch" | "prerelease" | "release";
export {};
